<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>
  
  

<body>
  <div class="container">
    <div class="text - center mt-4 mb-3">
      <h2>F100 - Quản trị người dùng</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group mb-0">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select name="" id="roleSelect" class="form-control"></select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead class="thead-dark">
        <tr>
          <th scope="col">STT</th>
          <th scope="col">User name</th>
          <th scope="col">First name</th>
          <th scope="col">Last Name</th>
          <th scope="col">Email</th>
          <th scope="col">Age</th>
          <th scope="col">Role</th>
          <th scope="col">Action</th>
        </tr>
      </thead>
    </table>
  </div>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager" 
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];

  var gSTT = 1;
  const gTABLE_ROW = ["id", "username", "firstname", "lastname", "age", "email", "roleId", "action"];
  const gSTT_COL = 0;
  const gUSERNAME_COL = 1;
  const gFIRSTNAME_COL = 2;
  const gLASTNAME_COL = 3;
  const gAGE_COL = 4;
  const gEMAIL_COL = 5;
  const gROLE_COL = 6;
  const gACTION_COL = 7;

  var gTable = $("#user-table").DataTable({
    columns: [
      {data: gTABLE_ROW[gSTT_COL]},
      {data: gTABLE_ROW[gUSERNAME_COL]},
      {data: gTABLE_ROW[gFIRSTNAME_COL]},
      {data: gTABLE_ROW[gLASTNAME_COL]},
      {data: gTABLE_ROW[gAGE_COL]},
      {data: gTABLE_ROW[gEMAIL_COL]},
      {data: gTABLE_ROW[gROLE_COL]},
      {data: gTABLE_ROW[gACTION_COL]},
    ],
    columnDefs: [
      {
        targets: gSTT_COL,
        render: function() {
          return gSTT++;
        }
      },
      {
        targets: gROLE_COL,
        render: getRoleNameByRoleId
      },
      {
        targets: gACTION_COL,
        defaultContent: `
          <i class="fas fa-dice text-success" title="Dice History" role="button"></i>
          <i class="fas fa-gift text-success ml-2" title="Voucher History" role="button"></i>
        `
      }
    ]
  })
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function() {
    // gán sự kiện load trang/F5
    onPageLoading();
    // gán sự kiện click button Lọc dữ liệu
    $(document).on("click", "#btn-filter-role", onBtnFilterClick);
  })
  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // function xử lý sự kiện load trang/F5
  function onPageLoading() {
    loadRoleDataToSelect();
    getDataAndDisplayTable(gUserObjects);
  }

  // function xử lý sự kiện click button Lọc dữ liệu
  function onBtnFilterClick() {
    // B1: Thu thập dữ liệu
    let vSelectRoleId = $("#roleSelect").val();
    let vFilterData = getFilterRoleData(vSelectRoleId);
    // B2: Kiểm tra dữ liệu
    // B3: Xử lý hiển thị
    getDataAndDisplayTable(vFilterData);
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // function xử lý hiển thị User data table
  function getDataAndDisplayTable(paramUserData) {
    gSTT = 1;
    gTable.clear();
    gTable.rows.add(paramUserData);
    gTable.draw();
  }

  // function tìm và hiển thị Role Name theo Role ID
  function getRoleNameByRoleId(paramRoleId) {
    let vRoleName = "";
    let vIndex = 0;
    let vFound = false;
    while (!vFound && vIndex < gRoleObjects.length) {
      if (gRoleObjects[vIndex].roleId == paramRoleId) {
        vRoleName = gRoleObjects[vIndex].roleName;
        vFound = true;
      }
      vIndex++;
    }
    return vRoleName;
  }

  // function gán Role data vào thẻ select
  function loadRoleDataToSelect() {
    for (let bRole of gRoleObjects) {
      $("#roleSelect").append(
        $("<option>").val(bRole.roleId).text(bRole.roleName)
      );
    }
  }

  // function xử lý hiển thị Filter Data
  function getFilterRoleData(paramRoleId) {
    let vFilterData = [];
    for (let bUser of gUserObjects) {
      if (bUser.roleId == paramRoleId) {
        vFilterData.push(bUser);
      }
    }
    return vFilterData;
  }
  
</script>

</html>